/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package gpioreader;

import java.io.IOException;
import java.util.concurrent.Semaphore;

import com.pi4j.io.gpio.exception.UnsupportedBoardType;
import com.pi4j.io.serial.Baud;
import com.pi4j.io.serial.DataBits;
import com.pi4j.io.serial.FlowControl;
import com.pi4j.io.serial.Parity;
import com.pi4j.io.serial.Serial;
import com.pi4j.io.serial.SerialConfig;
import com.pi4j.io.serial.SerialDataEvent;
import com.pi4j.io.serial.SerialDataEventListener;
import com.pi4j.io.serial.SerialFactory;
import com.pi4j.io.serial.StopBits;

public class Pi4JUSBSer {
	
	String[] data;
	int count = 0;
	final Serial serial;
	public boolean receivedUSBSerial = false;
	
	//Semaphore to manage multiple access to data in getValue() method
	Semaphore semaphor = new Semaphore(1, true);
	
	
	public Pi4JUSBSer(){
		// create an instance of the serial communications class
	     serial = SerialFactory.createInstance();
	    

	    // create and register the serial data listener
	    serial.addListener(new SerialDataEventListener() {
	        @Override
	        public void dataReceived(SerialDataEvent event) {
	        	
	            // NOTE! - It is extremely important to read the data received from the
	            // serial port.  If it does not get read from the receive buffer, the
	            // buffer will continue to grow and consume memory.

	            // print out the data received to the console
	            try {
	            	//value = ByteBuffer.wrap(event.getBytes()).getDouble();
	            	String in = event.getAsciiString();
	            	data = in.split(";");
	            	//System.out.println("This is " + data[0]);
	            	serial.write((char) 'a');
	            	receivedUSBSerial=true;
	            	/*if(count>=50){
	            	System.out.println("This is " + test + "\n" + event.getAsciiString());
	            	count=0;
	            	}
	            	count++;
	            	*/
	            	
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
	    });
	    
	    SerialConfig config = new SerialConfig();
        //Pi4jGPIODigi gpio1 = new Pi4jGPIODigi();
        
        // set default serial settings (device, baud rate, flow control, etc)
        //
        // by default, use the DEFAULT com port on the Raspberry Pi (exposed on GPIO header)
        // NOTE: this utility method will determine the default serial port for the
        //       detected platform and board/model.  For all Raspberry Pi models
        //       except the 3B, it will return "/dev/ttyAMA0".  For Raspberry Pi
        //       model 3B may return "/dev/ttyS0" or "/dev/ttyAMA0" depending on
        //       environment configuration.
        try {
			config.device("/dev/ttyACM0")
			      .baud(Baud._115200)
			      .dataBits(DataBits._8)
			      .parity(Parity.NONE)
			      .stopBits(StopBits._1)
			      .flowControl(FlowControl.NONE);			
			
			// open the default serial device/port with the configuration settings
	        serial.open(config);
	        
	        serial.write((byte) 100);
	        
		} catch (UnsupportedBoardType | IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
       
        /* continuous loop to keep the program running until the user terminates the program
        while(!stop) {
            try {
            	char charPort = Integer.toString(port).charAt(0);
            	serial.write(charPort);
            }
            catch(IllegalStateException ex){
                ex.printStackTrace();
            }
        }
        */
	}
	
	public void requestData(){
		//System.out.println("Request USB");
		try {
			semaphor.acquire();
			//Send message "1" to request data
        	char charPort = Integer.toString(1).charAt(0);
        	serial.write(charPort);
        	semaphor.release();
        }
        catch(IllegalStateException | IOException | InterruptedException ex){
            ex.printStackTrace();
        }
	}
	
	public Object getValue(int channel) {
		//System.out.println("Get from: " + channel);
		return Double.parseDouble(data[channel]);
	}    
}
