/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package gpioreader;

import com.pi4j.gpio.extension.base.AdcGpioProvider;
import com.pi4j.gpio.extension.mcp.MCP3008GpioProvider;
import com.pi4j.gpio.extension.mcp.MCP3008Pin;
import com.pi4j.io.gpio.GpioController;
import com.pi4j.io.gpio.GpioFactory;
import com.pi4j.io.gpio.GpioPinAnalogInput;
import com.pi4j.io.spi.SpiChannel;
import com.pi4j.io.spi.SpiDevice;


/**
 *
 * @author 
 */
public class Pi4jGPIO {

    AdcGpioProvider adcGPIOprov;
    GpioPinAnalogInput GPIOInput;

    public Pi4jGPIO(int channel) throws Exception {

        final GpioController gpio = GpioFactory.getInstance();

        adcGPIOprov = new MCP3008GpioProvider(
                SpiChannel.CS0,
                1000000,//1000000,
                SpiDevice.DEFAULT_SPI_MODE
        );
        switch (channel) {
            case 0:
                GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH0, "AnalogInput-CH" + channel);
                break;
            case 1:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH1, "AnalogInput-CH" + channel);
                break;
            case 2:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH2, "AnalogInput-CH" + channel);
                break;
            case 3:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH3, "AnalogInput-CH" + channel);
                break;
            case 4:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH4, "AnalogInput-CH" + channel);
                break;
            case 5:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH5, "AnalogInput-CH" + channel);
                break;
            case 6:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH6, "AnalogInput-CH" + channel);
                break;
            case 7:
            	GPIOInput = gpio.provisionAnalogInputPin(adcGPIOprov, MCP3008Pin.CH7, "AnalogInput-CH" + channel);
                break;
            default:
                break;
         }
    }
    

    public double getValue() {

        return GPIOInput.getValue();
    }
}
