/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package fusion.manager;

public class Algorithm implements AlgorithmInterface{
	
	private String UID;
	private String[] physPheno;
	private int inDimensionality;
	private int outDimensionality;
	private String dataType;
	private int dataLength;
	private String sourceIP;
	
	/**
	 * The Algorithm class represents a signal processing algorithm of an intelligent sensor.
	 * Semantic information as well as data processing are implemented and handled in this class
	 * @param UID
	 * @param suitablePhysPheno
	 * @param inputDimensionality
	 * @param outputDimensionality
	 * @param dataType
	 * @param dataLength
	 * @param sourceIP
	 */
	public Algorithm(String UID, String[] suitablePhysPheno, int inputDimensionality, int outputDimensionality, String dataType, int dataLength, String sourceIP){

		//Semantics
		this.UID = UID;
		this.physPheno = suitablePhysPheno;
		this.inDimensionality = inputDimensionality;
		this.outDimensionality = outputDimensionality;
		this.dataType = dataType;
		this.dataLength = dataLength;
		this.sourceIP = sourceIP;
	}

	@Override
	public String getUID() {
		// TODO Auto-generated method stub
		return UID;
	}

	@Override
	public String[] getPhysPheno() {
		// TODO Auto-generated method stub
		return physPheno;
	}

	@Override
	public String getDataType() {
		// TODO Auto-generated method stub
		return dataType;
	}

	@Override
	public int getDataLength() {
		// TODO Auto-generated method stub
		return dataLength;
	}

	@Override
	public String getIP() {
		// TODO Auto-generated method stub
		return sourceIP;
	}

	@Override
	public int getOutputDimensonality() {
		// TODO Auto-generated method stub
		return outDimensionality;
	}

	@Override
	public int getInputDimensonality() {
		// TODO Auto-generated method stub
		return inDimensionality;
	}

}
