/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package fusion.manager;

import java.util.List;
import java.util.concurrent.Semaphore;

/**
 * This class is for physical, functional, and quality attributes.
 * @author A_Fritze
 *
 */
public class AttributeGeneral extends Attribute{
	
	String attrType;
	String foi;

	public AttributeGeneral(String type, String attrType, String foi, List<String> suitablePhysPheno, List<String> suitableFeatures, Semaphore iiwowaSemaphore) {
		
		super(type, suitablePhysPheno, suitableFeatures, iiwowaSemaphore);
		this.foi = foi;
		this.attrType = attrType;
	}
	
	//Getter
	public String getAttrType(){
		return attrType;
	}
	public String getFoI(){
		return foi;
	}
}
