/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package fusion.manager;

import java.util.List;
import java.util.concurrent.Semaphore;

/**
 * A class for a Module Attribute. It extends the Attribute class by a feature of interest that represents the observed module.
 * @author A_Fritze
 *
 */
public class AttributeModule extends Attribute{
	
	String foi;

	public AttributeModule(String UID,	String foi, List<String> suitablePhysPheno, List<String> suitableFeatures, Semaphore iiwowaSemaphore) {
		
		super(UID, suitablePhysPheno, suitableFeatures, iiwowaSemaphore);
		this.foi = foi;
	}
	
	public String getFoi(){
		return foi;
	}
}
