/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */
package fusion.manager;

import java.util.ArrayList;
import java.util.List;

public class IntelligentSensor implements IntelligentSensorInterface{
	
	private String UID;
	private List<Sensor> sensors = new ArrayList<Sensor>();
	private List<Algorithm> algorithms = new ArrayList<Algorithm>();
	private String sourceIP;
	
	/**
	 * This class is for intelligent sensors. The main functionalities are implemented at the sensor- and algorithm-objects,
	 * which are part of the intelligent sensor. These are available from this class.
	 * @param UID
	 * @param sourceIP
	 */
	public IntelligentSensor(String UID, String sourceIP){
		this.UID = UID;
		this.sourceIP = sourceIP;
	}

	
	@Override
	public String getUID() {
		return UID;
	}

	@Override
	public List<Sensor> getElementarySensors() {
		return sensors;
	}

	@Override
	public List<Algorithm> getAlgorithms() {
		return algorithms;
	}
	
	@Override
	public void addElementarySensor(Sensor sensor) {
		sensors.add(sensor);
	}

	@Override
	public void addAlgorithm(Algorithm algorithm) {
		algorithms.add(algorithm);
		
	}
	
	@Override
	public String getIP() {
		return sourceIP;
	}


}
