/*
 * Copyright 2017 inIT - Institute Industrial IT

	This file is part of "Automated Fusion System Design and Adaptation Implementation.

    "Automated Fusion System Design and Adaptation Implementation is free software: 
	you can redistribute it and/or modify it under the terms of the GNU General Public 
	License as published by the Free Software Foundation, either version 3 of the 
	License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful, but WITHOUT ANY 
	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
	PARTICULAR PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along with this 
	program.  If not, see <http://www.gnu.org/licenses/>.
	
 * A copy of the GNU General Public License version 3 is provided in the file LICENSE.gpl3.0.txt .
 */

/**
 * An abstract implementation of a fuzzy membership function
 */

package fusion.manager.aggregation;


/** Parent class for classes that belong to the class of membership functions
 *
 * @author Alexander Fritze
 */
public abstract class FuzzyMembershipFunction
{
	private boolean trained = false;
	
	/** Returns whether or not the membership function has been trained
    *
    * @return a boolean indicating if the membership function has been trained
    */
   public boolean isTrained()
   {
       return trained;
   }

   /** Setter for setting the membership function to trained.
    *
    * @param trained boolean to set 
    */
   public void setTrained(boolean trained)
   {
       this.trained = trained;
   } 
      
}
